#ifndef _KGR_PATCH_BSC1183491_H
#define _KGR_PATCH_BSC1183491_H

#include <linux/types.h>

int kgr_patch_bsc1183491_scsi_transport_iscsi_init(void);
void kgr_patch_bsc1183491_scsi_transport_iscsi_cleanup(void);

static inline int kgr_patch_bsc1183491_libiscsi_init(void) { return 0; }
static inline void kgr_patch_bsc1183491_libiscsi_cleanup(void) {}

int kgr_patch_bsc1183491_init(void);
void kgr_patch_bsc1183491_cleanup(void);


struct device;
struct device_attribute;
struct sk_buff;
struct nlmsghdr;
struct iscsi_cls_session;
enum iscsi_param;
struct sockaddr_storage;
struct iscsi_cls_conn;
struct Scsi_Host;
enum iscsi_host_param;

ssize_t
kgrp_show_transport_handle(struct device *dev, struct device_attribute *attr,
		      char *buf);

ssize_t kgrp_show_transport_caps(struct device *dev, struct device_attribute *attr, char *buf);

ssize_t
kgrp_show_ep_handle(struct device *dev, struct device_attribute *attr, char *buf);

int
kgrp_iscsi_if_recv_msg(struct sk_buff *skb, struct nlmsghdr *nlh, uint32_t *group);

ssize_t
kgrp_show_priv_session_state(struct device *dev, struct device_attribute *attr,
			char *buf);

ssize_t
kgrp_show_priv_session_creator(struct device *dev, struct device_attribute *attr,
			char *buf);

ssize_t
kgrp_show_priv_session_target_id(struct device *dev, struct device_attribute *attr,
			    char *buf);

ssize_t kgrp_show_priv_session_recovery_tmo(struct device *dev, struct device_attribute *attr, char *buf);

int kgrp_iscsi_session_get_param(struct iscsi_cls_session *cls_session,
				   enum iscsi_param param, char *buf);

int kgrp_iscsi_conn_get_addr_param(struct sockaddr_storage *addr,
				     enum iscsi_param param, char *buf);

int kgrp_iscsi_conn_get_param(struct iscsi_cls_conn *cls_conn,
				enum iscsi_param param, char *buf);

int kgrp_iscsi_host_get_param(struct Scsi_Host *shost,
				enum iscsi_host_param param, char *buf);

#define KGR_PATCH_BSC1183491_FUNCS				\
	KGR_PATCH_OBJ(show_transport_handle,			\
		      kgrp_show_transport_handle,		\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(show_transport_caps,			\
		      kgrp_show_transport_caps,		\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(show_ep_handle,				\
		      kgrp_show_ep_handle,			\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(iscsi_if_recv_msg,			\
		      kgrp_iscsi_if_recv_msg,			\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(show_priv_session_state,			\
		      kgrp_show_priv_session_state,		\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(show_priv_session_creator,		\
		      kgrp_show_priv_session_creator,		\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(show_priv_session_target_id,		\
		      kgrp_show_priv_session_target_id,	\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(show_priv_session_recovery_tmo,		\
		      kgrp_show_priv_session_recovery_tmo,	\
		      "scsi_transport_iscsi"),			\
	KGR_PATCH_OBJ(iscsi_session_get_param,			\
		      kgrp_iscsi_session_get_param,		\
		      "libiscsi"),				\
	KGR_PATCH_OBJ(iscsi_conn_get_addr_param,		\
		      kgrp_iscsi_conn_get_addr_param,		\
		      "libiscsi"),				\
	KGR_PATCH_OBJ(iscsi_conn_get_param,			\
		      kgrp_iscsi_conn_get_param,		\
		      "libiscsi"),				\
	KGR_PATCH_OBJ(iscsi_host_get_param,			\
		      kgrp_iscsi_host_get_param,		\
		      "libiscsi"),				\

#endif /* _KGR_PATCH_BSC1183491_H */
